#!/usr/bin/python
# -*- coding: latin-1 -*-

#Import maya modules
import maya.cmds as cmds
import maya.mel as mel

#Import stuff 
import hmScripts.UI.hmGlobalVariables as gVar
# New
import hmScripts.UI.hmWindowHardMeshOperation as hardMeshOperationWindow
import hmScripts.UI.hmWindowIntersectionCurves as intersectionCurves
import hmScripts.UI.hmWindowIntersectionTubes as interTubes

reload(intersectionCurves)
reload(interTubes)
reload(hardMeshOperationWindow)



#!/usr/bin/env python
# -*- coding: utf-8 -*-

import hmScripts.UI.hmWindowInteractiveDockUI as dock

import hmScripts.UI.hmWindowSplit as splitWindow
import hmScripts.UI.hmWindowBlend as blendWindow
import hmScripts.UI.hmWindowSnap as snapWindow

reload(gVar)
reload(dock)

reload(splitWindow)
reload(blendWindow)
reload(snapWindow)


version20 = True

#the formula for discovering the variable where a menu is stored in MEL : "g" + View + Name + "Menu"

def hmMenu():

	manuName = 'hmMenuBar'

	#Window class init
	hMOpWin = hardMeshOperationWindow.HmHardMeshOperationWindow()




	if (cmds.menu( manuName, exists=True)):
		cmds.deleteUI( manuName )


 
	gMainWindow = mel.eval('$temp1=$gMainWindow')
	#Parent to this to add to editMesh menu
	#editMeshMenu = mel.eval('$temp2=$gMainEditMeshMenu')
	
	mainMenu = cmds.menu(manuName, p =  gMainWindow, to = True, l= 'Hard Mesh' )
	
	cmds.menuItem(parent = mainMenu, divider=True, dividerLabel = 'Windows')


	cmds.menuItem(parent= mainMenu, l='HM Window', c= openDockUi )
	#let the user choose if the window should appear on the left or on the right
	# cmds.menuItem(parent= mainMenu, l='left', rb=True, en=False )
	# cmds.menuItem(parent= mainMenu, l='right', rb=True, en=False )
	#cmds.menuItem(parent = mainMenu, l='Base Mesh Library', c='cmds.warning( \'empty command\')',  )
	
	#================ INTERACTIVE
	if version20:
		cmds.menuItem(parent = mainMenu, divider=True, dividerLabel = 'Mesh')
		cmds.menuItem(parent = mainMenu, l='Hard Mesh Operation', c=hMOpWin.performFromMenu )
		cmds.menuItem(parent = mainMenu,  l='Hard Mesh Operation', c= hMOpWin.buildAndShowWindow, ob=True )
		
		

	
	#================ EXPERIMENTAL
	if gVar.develop:

		tubeWin = interTubes.HmIntersectionTubesWindow()

		cmds.menuItem(parent = mainMenu, divider=True, dividerLabel = '___DEVELOPMENT___')
		cmds.menuItem(parent = mainMenu, divider=True, dividerLabel = 'Curves Operations')

		cmds.menuItem(parent = mainMenu, l='Tube intersection', c=tubeWin.performFromMenu )
		cmds.menuItem(parent = mainMenu,  l='Tube intersection', c= tubeWin.buildAndShowWindow, ob=True )
	
	if gVar.intersectCommand:

		interCrv = intersectionCurves.HmIntersectionCurvesWindow()	

		cmds.menuItem(parent = mainMenu, l='Intersection Curves', c=interCrv.performFromMenu )
		cmds.menuItem(parent = mainMenu,  l='Intersection Curves', c= interCrv.buildAndShowWindow, ob=True )

	if gVar.develop:

		splitWin = splitWindow.HmSplitWindow()
		blendWin = blendWindow.HmBlendWindow()
		snapWin = snapWindow.HmSnapWindow()


		cmds.menuItem(parent = mainMenu, l='Split From Curves', c=splitWin.performFromMenu )
		cmds.menuItem(parent = mainMenu,  l='Split From Curves', c= splitWin.buildAndShowWindow, ob=True )
		
		cmds.menuItem(parent = mainMenu, divider=True, dividerLabel = 'Mesh Components')
		cmds.menuItem(parent = mainMenu, l='Blend From Edges', c=blendWin.performFromMenu )
		cmds.menuItem(parent = mainMenu,  l='Blend From Edges', c= blendWin.buildAndShowWindow, ob=True )


		cmds.menuItem(parent = mainMenu, divider=True, dividerLabel = 'Bonus')

		cmds.menuItem(parent = mainMenu, l='Snap To Curve', c=snapWin.performFromMenu  )
		cmds.menuItem(parent = mainMenu, l='Snap To Curve', c=snapWin.buildAndShowWindow, ob=True )
		
		cmds.menuItem(parent = mainMenu, l='Mesh Library', c='cmds.warning( \'empty command\')',  )
		cmds.menuItem(parent = mainMenu, l='Mesh Library', c='cmds.warning( \'empty command\')', ob=True )
		
		
		cmds.menuItem(parent = mainMenu, l='Edge Control', c='cmds.warning( \'empty command\')',  )
		cmds.menuItem(parent = mainMenu, l='Edge Control', c='cmds.warning( \'empty command\')', ob=True )
		
		cmds.menuItem(parent = mainMenu, l='Circular Hole', c='cmds.warning( \'empty command\')',  )
		cmds.menuItem(parent = mainMenu, l='Circular Hole', c='cmds.warning( \'empty command\')', ob=True )

def openDockUi(*args):
	dock.HardMeshDockUI()
	
def hmMayaIntegration():
	'''
	calling this will merge the hm commands to maya menu..
	'''
	
def updateNet():
	'''
	Update old scenes by breaking connections from compound to offset.
	'''

	# List all offset nodes
	offsetNodes = cmds.ls(type = 'hmOffsetCurveNode')
	# break the connections of the offset A and B
	for node in offsetNodes:
		# Query the connections for both channels
		for channel in [gVar.offsetA, gVar.offsetB]:
			connected = cmds.listConnections('%s.%s' % (node, channel), p=True)
			#if there is a connection
			if connected:
				try:
					# Build the strings
					driver = connected[0]
					driven = '%s.%s' % (node, channel)
					# Break the connection
					cmds.disconnectAttr(driver, driven)
				except:
					cmds.warning('unable to fix node %s' % node)
				else:
					print('fixed %s' % node)

	

