#!/usr/bin/env python
# -*- coding: utf-8 -*-

import re

def getPathFromLongName(stringLongName ):
	list = stringLongName.split( '|' ) #splittiamo..
	list.remove( list[len(list) -1] ) #togliamo il nome finale..
	path = '|'.join(list) + '|' #ricomponiamo una stringa senza il nome finale..
	return path

def hasNumbers(inputString):
	'''
	Query if the string contains numbers and.. return them?
	'''
	return any(char.isdigit() for char in inputString)
	
def getNumbers(inputString):
	#return [int(s) for s in inputString.split() if s.isdigit()] #funziona solo se il numero ha uno spazio.
	return re.findall('\d+', inputString)
	
	
	
def flatten(x):
    '''
	flatten(sequence) -> list

    Returns a single, flat list which contains all elements retrieved
    from the sequence and all recursively contained sub-sequences
    (iterables).

    Examples:
    >>> [1, 2, [3,4], (5,6)]
    [1, 2, [3, 4], (5, 6)]
    >>> flatten([[[1,2,3], (42,None)], [4,5], [6], 7, MyVector(8,9,10)])
    [1, 2, 3, 42, None, 4, 5, 6, 7, 8, 9, 10]
	'''
    result = []
    for el in x:
        #if isinstance(el, (list, tuple)):
        if hasattr(el, "__iter__") and not isinstance(el, basestring):
            result.extend(flatten(el))
        else:
            result.append(el)
    return result
	