#!/usr/bin/env python
# -*- coding: utf-8 -*-


#We import both the base class for options window and the shared contents of the window
import hmScripts.UI.hmWindowBaseOption as hmBaseWin
reload(hmBaseWin)
import hmScripts.UI.hmOptionsIntersectionTubes as intersectionCurvesOpt
reload(intersectionCurvesOpt)


class HmIntersectionTubesWindow( hmBaseWin.HmOptionWindow ):
	'''
	This class implement the window for the Mesh Setup options.
	Is based on the baseWindow class and share the attributes defined in the hmMeshSetupOptions
	'''
	def __init__(self):
		#Here we define the current window name, overriding the original variable
		self.winName = 'Intersection_Curves'

		#Initialize the base class
		super( HmIntersectionTubesWindow, self ).__init__( self.winName  )

		#Initialize the UI content
		self.content = intersectionCurvesOpt.IntersectionTubesOptionsUI()


		#Override the tooltip for the execute button
		self.executeTooltip = self.content.getMainTooltip()


	def insertContent(self):
		'''
		Here we override the insert content method, adding the UI from the generic UI definition
		'''
		#Add the UI elements
		self.content.createUiElements()



	#======================================================================================
	def performFromMenu(self, *Args):
		'''
		This method create an hidden window for reading the options, execute the command and delete the ghost ui
		'''
		#Grate a ghost interface
		self.buildWindow()

		#Execute the command
		self.applyCmd()

		#Delete the ghost window
		self.deleteWindow()

	def applyCmd(self, *Args):
		'''
		Here we call the command, assuning that the interface is opened
		'''
		#Execute the command defined in the content of interface
		self.content.performCommand()
		#Display message from parent class
		super(HmIntersectionTubesWindow, self).applyCmd()


	def saveOptions(self, *Args):
		'''
		Use the common stuff from the base class and the UI method for saving
		'''
		#Save the values
		self.content.saveOptionsValues()
		#Display message from parent class
		super(HmIntersectionTubesWindow, self).saveOptions()


	def resetOptions(self, *Args):
		#Reset the values
		self.content.resetOptionsValues()
		#Display message from parent class
		super(HmIntersectionTubesWindow, self).saveOptions()

		